/* =============================================================================================== */
/* Copyright (c) 2010    (aka TheXpert)                                  */
/*                                                                                                 */
/*   , , ,               */
/*     (   " "),   */
/*     ,               */
/* , , , , , ,                 */
/*  /    ,    ,              */
/*     ,    :       */
/*                                                                                                 */
/*                                                                                                 */
/*                      */
/*    .                                                         */
/*                                                                                                 */
/*      ܻ,    ,        */
/*   , ,      ,   */
/*        .           */
/*         ,          */
/*    ,   ,  ,       */
/*                */
/*    .                                                          */
/* =============================================================================================== */

//+------------------------------------------------------------------+
//|                                           DragTrade_Property.mqh |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

#define PROP_ID " Property "

#include <DragTrade_v_1.0/DragTrade_SmartGlobals.mqh>

string PropertyNames[];
double LastPropertyValues[];

void InitProperties()
{
   ArrayResize(PropertyNames, 0);
   ArrayResize(LastPropertyValues, 0);
}

void SetProperty(string name, double value)
{
   string property = name + PROP_ID;
   SetGlobal(property, value);
   
   int pos = ArraySearchString(PropertyNames, property);
   if (pos != -1)
   {
      LastPropertyValues[pos] = value;
   }
   else
   {
      PushBackDouble(LastPropertyValues, value);
      PushBackString(PropertyNames, property);
   }
}

bool GetProperty(string name, double& value)
{
   string property = name + PROP_ID;
   bool res = GetGlobalSafe(property, value);
   
   if (res)
   {
      int pos = ArraySearchString(PropertyNames, property);
      if (pos == -1)
      {
         PushBackDouble(LastPropertyValues, value);
         PushBackString(PropertyNames, property);
      }
   }
   
   return (res);
}

bool InitProperty(string name, double defaultValue)
{
   double value;
   if (!GetProperty(name, value))
   {
      SetProperty(name, defaultValue);
   }
}

bool IsPropertyActual(string name)
{
   string property = name + PROP_ID;

   double global;
   if (!GetGlobalSafe(property, global)) return (false);
   
   int pos = ArraySearchString(PropertyNames, property);
   if (pos == -1)
   {
      PushBackDouble(LastPropertyValues, global);
      PushBackString(PropertyNames, property);
      return (true);
   }
   
   return (LastPropertyValues[pos] == global);
}

double UpdateProperty(string name)
{
   string property = name + PROP_ID;
   double actual = GetGlobal(property);

   int pos = ArraySearchString(PropertyNames, property);
   if (pos == -1)
   {
      PushBackDouble(LastPropertyValues, actual);
      PushBackString(PropertyNames, property);
   }
   else
   {
      LastPropertyValues[pos] = actual;
   }
   return (actual);
}